#include <stdio.h>
#include <stdlib.h>
#include <spi/include/kernel/memory.h>

void print_memory_usage( int32_t *rank32 )
{
  uint64_t shared, persist, heapavail, stackavail, stack, heap, guard, mmap, heapmax;

  Kernel_GetMemorySize(KERNEL_MEMSIZE_SHARED, &shared);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_PERSIST, &persist);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAPAVAIL, &heapavail);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_STACKAVAIL, &stackavail);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_STACK, &stack);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAP, &heap);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_GUARD, &guard);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_MMAP, &mmap);
  Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAPMAX, &heapmax);

  printf("Allocated heap: %.2f MB, avail. heap: %.2f MB, max. heap: %.2f MB\n", (double)heap/(1024*1024), (double)heapavail/(1024*1024), (double)heapmax/(1024*1024));
  printf("Allocated stack: %.2f MB, avail. stack: %.2f MB\n", (double)stack/(1024*1024), (double)stackavail/(1024*1024));
  printf("Memory: shared: %.2f MB, persist: %.2f MB, guard: %.2f MB, mmap: %.2f MB\n", (double)shared/(1024*1024), (double)persist/(1024*1024), (double)guard/(1024*1024), (double)mmap/(1024*1024));

  /*return 0;*/
}

void print_memusage()
{
uint64_t shared, persist, heapavail, stackavail, stack, heap, guard, mmap;

Kernel_GetMemorySize(KERNEL_MEMSIZE_GUARD, &guard);
Kernel_GetMemorySize(KERNEL_MEMSIZE_SHARED, &shared);
Kernel_GetMemorySize(KERNEL_MEMSIZE_PERSIST, &persist);
Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAPAVAIL, &heapavail);
Kernel_GetMemorySize(KERNEL_MEMSIZE_STACKAVAIL, &stackavail);
Kernel_GetMemorySize(KERNEL_MEMSIZE_STACK, &stack);
Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAP, &heap);
Kernel_GetMemorySize(KERNEL_MEMSIZE_MMAP, &mmap);
printf("MEMSIZE heap: %.2f/%.2f stack: %.2f/%.2f mmap: %.2f MB\n", (double)heap/(1024*1024), (double)heapavail/(1024*1024), (double)stack/(1024*1024), (double)stackavail/(1024*1024), (double)mmap/(1024*1024));
printf("MEMSIZE shared: %.2f persist: %.2f guard: %.2f MB\n", (double)shared/(1024*1024), (double)persist/(1024*1024), (double)guard/(1024*1024));
}


void get_memory_heap ( double *val )
{
  uint64_t v;
  Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAP, &v);
  *val = ((double)v)/(1024.0*1024.0);
}

void get_memory_heapavail ( double *val )
{
  uint64_t v;
  Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAPAVAIL, &v);
  *val = ((double)v)/(1024.0*1024.0);
}

void get_memory_heapmax ( double *val )
{
  uint64_t v;
  Kernel_GetMemorySize(KERNEL_MEMSIZE_HEAPMAX, &v);
  *val = ((double)v)/(1024.0*1024.0);
}

void get_memory_shared ( double *val )
{
  uint64_t v;
  Kernel_GetMemorySize(KERNEL_MEMSIZE_SHARED, &v);
  *val = ((double)v)/(1024.0*1024.0);
}

void get_memory_mmap ( double *val )
{
  uint64_t v;
  Kernel_GetMemorySize(KERNEL_MEMSIZE_MMAP, &v);
  *val = ((double)v)/(1024.0*1024.0);
}





